kayfabe.controller('kayfabeController', function($scope) {
	$scope.appStructure = [{"name":"Services","description":"","classes":[{"name":"DirectoryService","description":"Builds the list of files to be parsed by the ParsingService","variables":[{"name":"directories","description":"The array of files to be parsed","type":"Array"}],"methods":[{"name":"DirectoryService","description":"","parameters":[],"returns":null},{"name":"getFiles","description":"Retrievs the list of available files based on user options","parameters":[{"name":"baseDirectory","description":"The directory to begin the recursive search in","type":"String","optional":false},{"name":"options","description":"The search options","type":"Object","optional":false},{"name":"cb","description":"The callback function","type":"Function","optional":false}],"returns":null},{"name":"buildDirectories","description":"Builds the directory tree that the files to parse will be retrieved from","parameters":[{"name":"baseDirectories","description":"An array of directories to search","type":"Array","optional":false},{"name":"exclusions","description":"Filenames to exclude","type":"Array","optional":false},{"name":"cb","description":"The callback function","type":"Function","optional":false}],"returns":null},{"name":"getSubDirectories","description":"Retrieves the subdirectories of an array of parent directories","parameters":[{"name":"baseDirectories","description":"An array of directories to search","type":"Array","optional":false},{"name":"exclusions","description":"Filenames to exclude","type":"Array","optional":false},{"name":"cb","description":"The callback function","type":"Function","optional":false}],"returns":null}]},{"name":"InfoService","description":"Retrieves and displays options and information about kayfabe","variables":[],"methods":[{"name":"InfoService","description":"","parameters":[],"returns":null},{"name":"getOptions","description":"Retrieves kayfabe options and optionally appends them with settings from a package.json file","parameters":[],"returns":{"type":"Object","description":"kayfabe options"}}]},{"name":"ParsingService","description":"Parses the files returned by the DirectoryService and creates the application structure object.","variables":[{"name":"appStructure","description":"The object containing the documentation structure","type":"Object"}],"methods":[{"name":"ParsingService","description":"","parameters":[],"returns":null},{"name":"parse","description":"Initiates the parsing process","parameters":[{"name":"baseDirectory","description":"The directory command was run from","type":"String","optional":false},{"name":"options","description":"kayfabe options","type":"Object","optional":false},{"name":"cb","description":"The callback function","type":"Function","optional":false}],"returns":null},{"name":"buildAppStructure","description":"Iterates through files and sends them to be parsed","parameters":[{"name":"cb","description":"The callback function","type":"Function","optional":false}],"returns":null},{"name":"parseComments","description":"Parses a files comments and sends them to be created as the proper application structure element","parameters":[{"name":"comments","description":"An array of comment strings","type":"Array","optional":false}],"returns":null},{"name":"breakCommentIntoLines","description":"Breaks the lines of a comment into an array","parameters":[{"name":"comment","description":"A comment string","type":"String","optional":false}],"returns":{"type":"Array","description":"Comment lines"}},{"name":"getCategoryName","description":"Parses a category name from a comment line","parameters":[{"name":"commentLine","description":"A comment line string string containing '@category [name]'","type":"String","optional":false}],"returns":{"type":"String","description":"Category name"}},{"name":"getClassStructure","description":"Parses class information from a comment line","parameters":[{"name":"commentLine","description":"A comment line string containing '@class [name]'","type":"String","optional":false},{"name":"description","description":"The class description","type":"String","optional":false}],"returns":{"type":"Object","description":"Class structure"}},{"name":"createConstructor","description":"Parses constructor method information from a comment and inserts it into the current class","parameters":[{"name":"comment","description":"A comment array starting from the line containing '@constructor'","type":"Array","optional":false}],"returns":null},{"name":"createMethod","description":"Parses method information from a comment and inserts it into the current class","parameters":[{"name":"comment","description":"A comment array starting from the line containing '@constructor'","type":"Array","optional":false},{"name":"description","description":"The method description","type":"String","optional":false}],"returns":null},{"name":"getParameterStructure","description":"Parses method parameter information from a comment line","parameters":[{"name":"commentLine","description":"A comment line string containing ' {[type]} [name] [description]'","type":"String","optional":false}],"returns":{"type":"Object","description":"Parameter structure"}},{"name":"getReturnStructure","description":"Parses method return information from a comment line","parameters":[{"name":"commentLine","description":"A comment line string containing '@returns {[type]} [description]'","type":"String","optional":false}],"returns":{"type":"Object","description":"Return structure"}},{"name":"createVariable","description":"Parses variable information from a comment line and inserts it into the current class","parameters":[{"name":"commentLine","description":"A comment line string containing '@variable {[type]} [name]'","type":"String","optional":false},{"name":"description","description":"The variable description","type":"String","optional":false}],"returns":null},{"name":"insertStructureObject","description":"Inserts a structure element from a fully parsed comment into the application structure","parameters":[],"returns":null}]}]}];
});
